<template>
  <div class="col mb-3 text-end" v-if="liqBecasCabeceraStore.listadoInformeLiq.length > 0">

    <a :href="becasLiqImprimir(0)
      " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal p-1 px-2 mt-1">
      <i class="fa-solid fa-print me-1"></i> Imprimir PDF Detallado
    </a>
    <a :href="becasLiqImprimir(1)
      " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal mx-3 p-1 px-2 mt-1">
      <i class="fa-solid fa-print me-1"></i> Imprimir PDF Totales
    </a>
    <a :href="becasLiqImprimirExel()
      " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal  p-1 px-2 mt-1">
      <i class="fa-solid fa-table me-1"></i> Excel
    </a>
  </div>

  <div class="text-center">
    <table class="table  table-striped" v-if="liqBecasCabeceraStore.listadoInformeLiq.length > 0">
      <thead>
        <tr class="bg-princial text-light fs-4 text-uppercase">
          <th scope="col">Apellido y Nombre</th>
          <th scope="col">Doc N°</th>
          <th scope="col">Apellido y nombre Apoderado</th>
          <th scope="col">Doc Apoderado</th>
          <th scope="col">Líquido</th>
          <th scope="col" :style="{ 'width': '230px' }">Período - N° Líq </th>
          <th scope="col">Solicitante</th>
          <th scope="col">Bloque</th>
          <th scope="col">Responsable</th>
          <th scope="col">Suc Bapro</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="liq in liqBecasCabeceraStore.listadoInformeLiq" :key="liq.id_liq_cab">
          <td class="pt-3 pb-3 px-2" v-text="liq.apyn"></td>
          <td class="pt-3 pb-3 px-2" v-text="liq.doc"></td>
          <td class="pt-3 pb-3 px-2" v-text="liq.apyn_apoderado"></td>
          <td class="pt-3 pb-3 px-2" v-text="liq.doc_apoderado"></td>
          <td class="pt-3 pb-3 px-2" v-text="'$' + formatPrice(liq.Importe_total)"></td>
          <td class="pt-3 pb-3 px-2" v-text="liq.f_periodo + '- N° ' + liq.nro_liq"></td>
          <td class="pt-3 pb-3 px-2" v-text="liq.apyn_sol"></td>
          <td class="pt-3 pb-3 px-2" v-text="liq.d_dependen_sol"></td>
          <td class="pt-3 pb-3 px-2" v-text="liq.apyn_sol_resp"></td>
          <td class="pt-3 pb-3 px-3" v-text="liq.baprosuc + '-' + liq.d_bapro"></td>
        </tr>
      </tbody>
    </table>
    <div v-else class="alert alert-secondary" role="alert">
      No hay elementos para mostrar
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref, reactive } from "vue";
import { isEmpty } from "@hcd-bsas/vue3-components";
import { DateTime } from "luxon";
import http from "@/http";
import { getUrl } from "@/shared.js";

import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions, SweetAlertResult } from "sweetalert2";

//store
import { useLiqBecasCabeceraStore } from "@/stores/Liquidaciones/cabeceraBecas";

//componentes
import type CabeceraBecas from "@/entities/Liquidaciones/CabeceraBecas";




const props = defineProps({
  tipoConsulta: { type: String },
  paramBusqueda: { type: Object }

});

const liqBecasCabeceraStore = useLiqBecasCabeceraStore();


function formatDate(date: string | null) {

  if (date != null) {
    const fecha = date;
    const dt = DateTime.fromFormat(fecha, "yyyy-MM-dd HH:mm:ss.SSS");
    const fechaFormateada = dt.toFormat("dd/MM/yyyy HH:mm:ss");
    return fechaFormateada;
  }
}

function formatPrice(value: any) {
  let val = (value / 1).toFixed(2).replace('.', ',')
  return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".")
}

var data = reactive({
  liq: undefined as CabeceraBecas | undefined,

});

function becasLiqImprimir(detallado: number) {
  var queryParams: any = {
    /*     id_tabla_sol: isEmpty(props.parametros.solicitante) ? null : props.parametros.solicitante?.id_tabla_sol,
        id_becario: isEmpty(props.parametros.becario?.id_becario) ? null : props.parametros.becario?.id_becario,
        id_apoderado: isEmpty(props.parametros.apoderado?.id_apoderado) ? null : props.parametros.apoderado?.id_apoderado,
        id_bloque: isEmpty(props.parametros.bloque?.id_dependen) ? null : props.parametros.bloque?.id_dependen,
        f_desde: props.parametros.f_desde,
        f_hasta: props.parametros.f_hasta,
        id_expte: isEmpty(props.parametros.id_expte) ? null : props.parametros.id_expte,
        id_tabla_sol_responsable: isEmpty(props.parametros.responsable?.id_tabla_sol_responsable) ? null : props.parametros.responsable?.id_tabla_sol_responsable,
        baprosuc: isEmpty(props.parametros.baproSucursal) ? null : props.parametros.baproSucursal,
        id_beca: null,
        estado: props.parametros.estado,
        usar_perfil_consulta: 0,
        cond_visado: props.parametros.visado.id_visado,
        orden: props.parametros.orden,
        detallado:detallado, */
  }
  return getUrl('becasLiqImprimir', [], queryParams);

}

function becasLiqImprimirExel() {
  var queryParams: any = {
    /*     id_tabla_sol: isEmpty(props.parametros.solicitante) ? null : props.parametros.solicitante?.id_tabla_sol,
        id_becario: isEmpty(props.parametros.becario?.id_becario) ? null : props.parametros.becario?.id_becario,
        id_apoderado: isEmpty(props.parametros.apoderado?.id_apoderado) ? null : props.parametros.apoderado?.id_apoderado,
        id_bloque: isEmpty(props.parametros.bloque?.id_dependen) ? null : props.parametros.bloque?.id_dependen,
        f_desde: props.parametros.f_desde,
        f_hasta: props.parametros.f_hasta,
        id_expte: isEmpty(props.parametros.id_expte) ? null : props.parametros.id_expte,
        id_tabla_sol_responsable: isEmpty(props.parametros.responsable?.id_tabla_sol_responsable) ? null : props.parametros.responsable?.id_tabla_sol_responsable,
        baprosuc: isEmpty(props.parametros.baproSucursal) ? null : props.parametros.baproSucursal,
        id_beca: null,
        estado: props.parametros.estado,
        usar_perfil_consulta: 0,
        cond_visado: props.parametros.visado.id_visado,
        orden: props.parametros.orden, */
  }
  return getUrl('becasLiqImprimirExel', [], queryParams);

}



</script>
